<template>
    <div class="content">
        <Userlist :contacts="contacts" @selected="startConversationWith"/>
        <MessageContact :messages="messages" :contact="selectedContact" @new="newMessageSave"/>
    </div>
</template>

<script>
    import Userlist from './Userlist'
    import MessageContact from './MessageContact'
    export default {
        props:{
            user:{
                type: Object,
                required: true,
            }
        },
        data(){
            return {
                selectedContact: null,
                messages:[],
                contacts:[],
            }
        },
        mounted() {
            Echo.private(`messages.${this.user.id}`)
                .listen('MessageEvent',(e)=>{
                    this.handleIncomingMessage(e.message);
                });
            axios.get('contacts').then((response)=>{
               this.contacts=response.data;
            });
        },
        methods:{
            startConversationWith(contact){
                this.updateUnreadCount(contact, true);
                axios.get(`/get/message/${contact.id}`)
                .then((response) =>{
                   this.messages = response.data;
                   this.selectedContact = contact;
                });
            },
            newMessageSave(message){
                this.messages.push(message);
            },
            handleIncomingMessage(message){
                if (this.selectedContact && message.sender_id === this.selectedContact.id){
                    this.newMessageSave(message);
                    return;
                }
                this.updateUnreadCount(message.fromContact, false);
            },
            updateUnreadCount(contact, reset) {
                this.contacts = this.contacts.map((single) => {
                    if (single.id !== contact.id) {
                        return single;
                    }

                    if (reset)
                        single.unread = 0;
                    else
                        single.unread += 1;

                    return single;
                })
            }
        },
        components: {Userlist,MessageContact}
    }
</script>
